package xyz.zhouxy.plusone.exception;

import xyz.zhouxy.plusone.commons.exception.BaseException;

/**
 * 业务异常
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
public class BizException extends BaseException {
    @java.io.Serial
    private static final long serialVersionUID = -5524759033245815405L;

    public static final String DEFAULT_ERROR_CODE = "4000000";

    public BizException(String code, String msg) {
        super(code, msg);
    }

    public BizException(String code, Throwable cause) {
        super(code, cause);
    }

    public BizException(String code, String msg, Throwable cause) {
        super(code, msg, cause);
    }

    public static BizException of(String msg) {
        return new BizException(DEFAULT_ERROR_CODE, msg);
    }

    public static BizException of(Throwable cause) {
        return new BizException(DEFAULT_ERROR_CODE, cause);
    }

    public static BizException of(String msg, Throwable cause) {
        return new BizException(DEFAULT_ERROR_CODE, msg, cause);
    }
}
