package xyz.zhouxy.plusone.system.domain.model.account;

import java.util.regex.Pattern;

import xyz.zhouxy.plusone.commons.annotation.StaticFactoryMethod;
import xyz.zhouxy.plusone.commons.annotation.ValueObject;
import xyz.zhouxy.plusone.commons.constant.PatternConsts;

/**
 * 值对象：用户名
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
@ValueObject
public class Username extends Principal {

    public static final Pattern REGEX = PatternConsts.USERNAME;

    private Username(String username) {
        super(username, REGEX);
    }

    @StaticFactoryMethod(Username.class)
    public static Username of(String username) {
        return new Username(username);
    }

    @Override
    protected String safeValue() {
        // 不需要脱敏。
        return value();
    }
}
